Z:=Integers();
teich:=func<x|x*Exp(-Log(x^(p-1))/(p-1)) where p:=Prime(Parent(x))>;

function Lr(B,q,r)
 return Multiplicity([FractionalPart(b+r/(q-1)) : b in B],0); end function;

function Tfr(A,B,p,f,r) q:=p^f;
 return &+[FractionalPart(p^i*(a+r/(q-1))) : a in A,i in [0..f-1]]
       -&+[FractionalPart(p^i*(b+r/(q-1))) : b in B,i in [0..f-1]];
end function;

function XandTqr(A,B,p,f,r,t,Qp) q:=p^f;
 Av:=&*[Gamma(Qp!FractionalPart(p^i*(a+r/(q-1)))) : i in [0..f-1], a in A];
 Bv:=&*[Gamma(Qp!FractionalPart(p^i*(b+r/(q-1)))) : i in [0..f-1], b in B];
 Xqr:=Av/Bv; mr:=Lr(B,p^f,r); return (Qp!Xqr)/q^mr,Tfr(A,B,p,f,r);
 end function;
function get_traceK(A,B,d,p,f,t,Qp)
 q:=p^f; C0,v:=XandTqr(A,B,p,f,0,t,Qp); u:=p^(f*d); T:=teich(t*Qp.1);
 for r in [1..q-2] do Cr,w:=XandTqr(A,B,p,f,r,t,Qp);
  u:=u+q^d*T^r*(Cr/C0)*(Qp!-p)^(Z!(w-v)); end for;
 return u/(1-q); end function;

intrinsic HypergeometricTraceKNew
(A::SeqEnum[RngElt],B::SeqEnum[RngElt],t::RngElt,q::RngIntElt
 : Precision:=5, ZigZagD := []) -> FldPadElt
{Given arrays of rationals for alphas and betas and a prime power q
 and a (rational) specialization t, return the HypergeometricTrace}
 require Type(Precision) eq RngIntElt and Precision ge 1: "Bad precision";
 require q ge 2: "q must be at least 2"; b,p,f:=IsPrimePower(q);
 require b: "q must be a prime power"; Qp:=pAdicField(p,Precision);
 A:=Sort([FractionalPart(a) : a in A]); B:=Sort([FractionalPart(b) : b in B]);
  if not (ZigZagD cmpeq []) then d := ZigZagD; else
 s:=0; T:=FunctionField(Rationals()).1; F:=Parent(t)!0;
 S:=[<x,0> : x in A] cat [<1-x,1> : x in B]; Sort(~S);
 for i in [1..2*#A] do
  if S[i][2] eq 0 then F:=F+T^s; s:=s+1; else s:=s-1; end if; end for;
 d:=Degree(Denominator(F)); end if; return get_traceK(A,B,d,p,f,t,Qp); end intrinsic;

intrinsic HypergeometricEulerFactorKNew
(A::SeqEnum[RngElt],B::SeqEnum[RngElt],t::RngElt,q::RngIntElt
 : Precision:=5, Recognize := true, ZigZagD := []) -> RngUPolElt
{Given arrays of rationals for alphas and betas and a prime power q
 and a (rational) specialization t, return the hypergeometric Euler factor over QQ if Recognize}

  d := #A; assert d eq #B;
  traces := [HypergeometricTraceKNew(A,B,t,q^k : Precision := Precision, ZigZagD := ZigZagD) : k in [1..d]];
  _<T> := PowerSeriesRing(Universe(traces));
  pol_padic := Exp(-&+[traces[r]*T^r/r : r in [1..d]]) + O(T^(d+1));
  if not Recognize then
    return Polynomial(AbsEltseq(pol_padic));
  else
    return Polynomial([Roots(PowerRelation(c, 1),Rationals())[1][1] : c in AbsEltseq(pol_padic)]);
  end if;
end intrinsic;

intrinsic HypergeometricEulerFactorsKNew
(ABs::SeqEnum[SeqEnum],t::RngElt,q::RngIntElt
 : Precision:=5, Recognize := true, ZigZagD := []) -> RngUPolElt
{Given arrays of rationals in ABs and a prime power q
 and a (rational) specialization t, return the product of hypergeometric Euler factors over QQ}

  pols_padic := [];
  for i := 1 to #ABs do
    A := ABs[i][1];
    B := ABs[i][2];
    d := #A; assert d eq #B;
    traces := [HypergeometricTraceKNew(A,B,t,q^k : Precision := Precision, ZigZagD := ZigZagD) : k in [1..d]];
    _<T> := PowerSeriesRing(Universe(traces));
    pol_padic := Exp(-&+[traces[r]*T^r/r : r in [1..d]]) + O(T^(d+1));
    Append(~pols_padic, Polynomial(AbsEltseq(pol_padic)));
  end for;
  pol_padic := &*pols_padic;
  if not Recognize then
    return pol_padic;
  else
    return Polynomial([Roots(PowerRelation(c, 1),Rationals())[1][1] : c in Eltseq(pol_padic)]);
  end if;
end intrinsic;
